var gulp = require("gulp"),
    pkg = require("./package.json");

gulp.task("compile", function() {
    var browserify = require("browserify"),
        source     = require("vinyl-source-stream"),
        umd        = require("gulp-umd"),
        buffer     = require("vinyl-buffer"),
        literalify = require("literalify"),
        replace    = require("gulp-replace"),
        bundler;

    bundler = browserify();
    bundler.transform(literalify.configure({
        "jquery": "_$",
        "packir": "_packir"
    }));

    bundler.require("./lib/plugin/jquery.js", { expose: 'jquery-packir' });

    return bundler.bundle()
        .pipe(source("jquery.packir.js"))
        .pipe(buffer())
        .pipe(replace(/\.catch\(/gi, "['catch']("))
        .pipe(umd({
            exports: function(file) {
                return 'require("jquery-packir")';
            },
            namespace: function(file) {
                return '$packir';
            },
            dependencies: function(file) {
                return [
                    {
                        name: '_$',
                        amd: 'jquery',
                        cjs: 'jquery',
                        global: 'jQuery'
                    },
                    {
                        name: '_packir',
                        amd: 'packir',
                        cjs: 'packir',
                        global: 'packir'
                    }
                ];
            }
        }))
        .pipe(gulp.dest("./dist"));
});